libzypp: zyppng::AbstractDirectSpawnEngine Class Reference

libzypp 17.38.14

zyppng::AbstractDirectSpawnEngine Class Reference

`#include <zypp-core/ng/io/private/forkspawnengine_p.h>`

Inheritance diagram for zyppng::AbstractDirectSpawnEngine:

## Public Member Functions
| ~AbstractDirectSpawnEngine () override
bool | isRunning (bool wait=false) override
bool | waitForExit (const std::optional< uint64_t > &timeout={}) override
Public Member Functions inherited from zyppng::AbstractSpawnEngine
| AbstractSpawnEngine ()
virtual | ~AbstractSpawnEngine ()
int | exitStatus () const
void | setExitStatus (const int state)
const std::string & | executedCommand () const
const std::string & | execError () const
void | setExecError (const std::string &str)
zypp::Pathname | chroot () const
void | setChroot (const zypp::Pathname &chroot)
bool | useDefaultLocale () const
void | setUseDefaultLocale (bool defaultLocale)
Environment | environment () const
void | setEnvironment (const Environment &environment)
pid_t | pid ()
virtual bool | start (const char *const *argv, int stdin_fd, int stdout_fd, int stderr_fd)=0
virtual void | notifyExited (int status)
bool | dieWithParent () const
void | setDieWithParent (bool dieWithParent)
bool | switchPgid () const
void | setSwitchPgid (bool switchPgid)
zypp::Pathname | workingDirectory () const
void | setWorkingDirectory (const zypp::Pathname &workingDirectory)
const std::vector< int > & | fdsToMap () const
void | addFd (int fd)
int | checkStatus (int status)

## Protected Member Functions
void | mapExtraFds (int controlFd=-1)
void | resetSignals ()

## Additional Inherited Members
Public Types inherited from zyppng::AbstractSpawnEngine
using | Environment = std::map<std::string,std::string>
| For passing additional environment variables to set.
Static Public Member Functions inherited from zyppng::AbstractSpawnEngine
static std::unique_ptr< zyppng::AbstractSpawnEngine > | createDefaultEngine ()
Protected Attributes inherited from zyppng::AbstractSpawnEngine
bool | _useDefaultLocale = false
bool | _dieWithParent = false
| Should the process die with the parent process.
bool | _switchPgid = false
pid_t | _pid = -1
int | _exitStatus = 0
std::string | _execError
| Remember execution errors like failed fork/exec.
std::optional< std::string > | _childExecDetail
| Error detail to remember if checkStatus sets an _execError.
std::string | _executedCommand
| Store the command we're executing.
std::vector< std::string > | _args
| The arguments we want to pass to the program.
Environment | _environment
| Environment variables to set in the new process.
zypp::Pathname | _chroot
| Path to chroot into.
zypp::Pathname | _workingDirectory
| Working directory.
std::vector< int > | _mapFds
| Additional file descriptors we want to map to the new process.

## Detailed Description

Definition at line 9 of file forkspawnengine_p.h.

## Constructor & Destructor Documentation

## ◆ ~AbstractDirectSpawnEngine()

zyppng::AbstractDirectSpawnEngine::~AbstractDirectSpawnEngine | ( |  | ) |
| override

Definition at line 35 of file forkspawnengine.cc.

## Member Function Documentation

## ◆ isRunning()

bool zyppng::AbstractDirectSpawnEngine::isRunning | ( | bool | wait = false | ) |
| overridevirtual

Implements zyppng::AbstractSpawnEngine.

Definition at line 44 of file forkspawnengine.cc.

## ◆ waitForExit()

bool zyppng::AbstractDirectSpawnEngine::waitForExit | ( | const std::optional< uint64_t > & | timeout = {} | ) |
| overridevirtual

Implements zyppng::AbstractSpawnEngine.

Definition at line 67 of file forkspawnengine.cc.

## ◆ mapExtraFds()

void zyppng::AbstractDirectSpawnEngine::mapExtraFds | ( | int | controlFd = -1 | ) |
| protected

Definition at line 136 of file forkspawnengine.cc.

## ◆ resetSignals()

void zyppng::AbstractDirectSpawnEngine::resetSignals | ( |  | ) |
| protected

Definition at line 216 of file forkspawnengine.cc.

The documentation for this class was generated from the following files:

- zypp-core/ng/io/private/forkspawnengine_p.h
- zypp-core/ng/io/forkspawnengine.cc